/**********************************************************************
 * imap4_write.h                                         September 1999
 * Horms                                             horms@valinux.com.
 * VA Linux System                                 http://valinux.com./
 *
 * Subroutines to write IMAP4 protocol output
 *
 * Licenced under the terms of the GNU GPL
 *
 **********************************************************************/

#ifndef IMAP4_WRITE_FLIM
#define IMAP4_WRITE_FLIM

#include "log.h"
#include "str.h"
#include "token.h"


#define IMAP4_GREETING "IMAP4 Ready"
#define IMAP4_QUIT "LOGOUT"
#define IMAP4_OK "OK"
#define IMAP4_BAD "BAD"
#define IMAP4_NO "NO"
#define IMAP4_UNTAGED "*"
#define IMAP4_DEFAULT_PORT "143"
#define IMAP4_ONE_TIME_TAG "flim7"

#ifndef IMAP4_CAPABILITIES
#define IMAP4_CAPABILITIES "IMAP4"
#endif

int imap4_write(
  const int fd, 
  const token_t *tag, 
  const char *type, 
  const char *string
);

#endif

