/**********************************************************************
 * pop3.c                                                September 1999
 * Horms                                             horms@valinux.com.
 * VA Linux System                                 http://valinux.com./
 *
 * POP3 protocol defines
 *
 * Licenced under the terms of the GNU GPL
 *
 **********************************************************************/

#include "pop3.h"

/**********************************************************************
 * pop3_intitialise_protocol
 * Intialialoise the protocol structure for the pop3 protocol
 * Pre: protocol: pointer to an allocated protocol structure
 * Post: Return seeded protocol stricture
 *              NULL on error
 **********************************************************************/

char *pop3_type[]={POP3_OK, POP3_ERR, POP3_ERR};

protocol_t *pop3_initialise_protocol(protocol_t *protocol){
  extern char *pop3_type[];

  protocol->type = pop3_type;
  protocol->write = (
    int (*)(const int, const token_t *, const char *, const char *)
  ) pop3_write;
  protocol->greeting_string = POP3_GREETING;
  protocol->quit_string = POP3_QUIT;
  protocol->one_time_tag = "QUIT";
  protocol->in_get_pw= (
    struct passwd *(*)(const int, const int, token_t **)
  ) pop3_in_get_pw;
  protocol->out_authenticate= (
    int (*)(
      const int, 
      const int, 
      const struct passwd *,
      protocol_t *
    )
  ) pop3_out_authenticate;
  protocol->in_authenticate= (
    int (*)(
      const struct passwd *pw,
      const int err_fd,
      const token_t *tag
    )
  ) pop3_in_authenticate;
  protocol->out_response= (
    int (*)(
      const int, 
      const char *,
      const token_t *,
      queue **
    )
  ) pop3_out_response;
  protocol->destroy = (void (*)(protocol_t *)) pop3_destroy_protocol;
  protocol->port = (char *(*)(const char *)) pop3_port;

  return(protocol);
}


/**********************************************************************
 * pop3_destroy_proto 
 * Destory protocol specifig elements of the protocol struture
 **********************************************************************/

void pop3_destroy_protocol(protocol_t *protocol){
  ;
}


/**********************************************************************
 * pop3_port 
 * Return the port to be used
 * pre: port: port that has been set
 * post: POP3_DEFAULT_PORT if port is PERDITION_PORT_PROTOCOL_DEPENDANT
 *       port otherwise
 **********************************************************************/

char *pop3_port(char *port){
  if(!strcmp(PERDITION_PORT_PROTOCOL_DEPENDANT, port)){
    return(POP3_DEFAULT_PORT);
  }

  return(port);
}
