/**********************************************************************
 * pop3_in.h                                             September 1999
 * Horms                                             horms@valinux.com.
 * VA Linux System                                 http://valinux.com./
 *
 * Handle pop commands from a client
 *
 * Licenced under the GNU GPL
 *
 **********************************************************************/

#ifndef POP3_IN_BLUM
#define POP3_IN_BLUM

#ifdef HAVE_CONFIG_H
#include "../config.h" 
#endif

#include <pwd.h>
#include <sys/types.h>
#include <sys/utsname.h>

#include "queue.h"
#include "token.h"
#include "pop3_write.h"
#include "log.h"
#include "perdition_types.h"
#include "daemon.h"
#include "str.h"
#include "queue_func.h"
#include "pam.h"

struct passwd *pop3_in_get_pw(const int in_fd, const int out_fd, token_t **tag);

int pop3_in_authenticate(
  const struct passwd *pw,
  const int err_fd,
  const token_t *tag
);

int pop3_in_greeting(const int fd);

#endif
